#include "courselib.h"
#include <cmath>
#include "TH1.h"
#include "TFile.h" 
#include <iostream>
using namespace std;

/*
	Testing Monte Carlo integration.
	We have a test function:  g0=3x**2
      We weight the histo with the function value.
	It is integrated over the region from 0 to 1.
	The random number generator is ranlux.

	We calculate the result and its error.
      
	The random number generator is RANLUX by M. Luescher.
      M. Lscher, A portable high-quality random number generator 
      for lattice field theory simulations, 
      Computer Physics Communications 79 (1994) 100  
*/



int main(int argc,char **argv)
{
	int n1, npoints = 10000000;
 	double x0;
      double xg0, xg00, f, ff, sigma2, error;
#define LVEC 1
	double rvec[LVEC];
      
      xg0 = xg00 = 0;
// initialise random number generator
//    rlxd_init( luxory level, seed )
      rlxd_init(2,32767);
      
	for ( n1 = 0; n1 < npoints; n1++ ) {
            ranlxd(rvec,LVEC);
		x0 = rvec[0];
// insert here the function you want to integrate:
//            f= ????; 
            ff = f;
            xg0 = xg0 + ff;
            xg00 = xg00 + ff*ff; 
//                                  
	}

      xg0 = xg0/npoints;
      xg00 = xg00/npoints;
      sigma2 = xg00 - xg0*xg0 ;
      error = sqrt(sigma2/npoints) ;
      cout<<" integral for 3x**2 is: "<<xg0<<"+/-"<< error<<endl;
      cout<<" true integral for 3x**2 is : 1.0 "<< endl;
	return(0);
}

